/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef MY_DOWNLOAD_EDITOR
#define MY_DOWNLOAD_EDITOR
#include <gtk/gtk.h>
#include <time.h>
#include "../dlist.h"
#include "../history.h"
struct tProxyWidget{
	GtkWidget *frame;
	GtkWidget *http_proxy_host,*http_proxy_port,*http_proxy_pass,*http_proxy_user,*http_proxy_user_check,*http_proxy_check;
	GtkWidget *ftp_proxy_host,*ftp_proxy_port,*ftp_proxy_pass,*ftp_proxy_user,*ftp_proxy_user_check,*ftp_proxy_check;
	GtkWidget *ftp_proxy_type_ftp,*ftp_proxy_type_http;
	void init();
	void init_state();
	void init_state(tCfg *cfg,int proto);
	void apply_changes();
	void apply_changes(tCfg *cfg,int proto);
};

class tDEdit{
	tDownload *parent;
	GtkWidget *pass_entry,*user_entry,*path_entry,*url_entry;
	GtkWidget *timeout_entry,*attempts_entry,*sleep_entry;
	GtkWidget *use_pass_check,*ftp_passive_check,*permisions_check,*get_date_check;
	GtkWidget *dir_browser;
	GtkWidget *button;
	GtkWidget *time_check;
	GtkWidget *year_entry,*month_entry,*day_entry,*hour_entry,*minute_entry;
	tProxyWidget *proxy;
	void setup_time(time_t when);
	public:
		GtkWidget *ok_button,*cancel_button;
		GtkWidget *window;
		tDEdit();
		void init(tDownload *who);
		void init_browser();
		void done_browser();
		void browser_ok();
		int apply_changes();
		void setup_entries();
		void toggle_time();
		void paste_url();
		void select_url();
		void clear_url();
		void set_url(char *a);
		void done();
		void popup();
		~tDEdit();
};


void init_edit_window(tDownload *what);
GList *make_glist_from_mylist(tHistory *parent);
GtkWidget *my_gtk_combo_new(tHistory *history);

#endif