/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "meter.h"
#include <stdio.h>

void tMeterNode::print() {
    //printf("%i\n",key);
};

//************************************************

tMeter::tMeter() {
    sort=new tSortTree;
};

void tMeter::add(int speed) {
    tMeterNode *temp=new tMeterNode;
    temp->key=speed;
    insert(temp);
    sort->add(temp);
};

void tMeter::dispose() {
    sort->del((tMeterNode *)First);
    tQueue::dispose();
};

tMeterNode *tMeter::first() {
    return (tMeterNode *)(Curent=First);
};

tMeterNode *tMeter::last() {
    return (tMeterNode *)(Curent=Last);
};

tMeterNode *tMeter::next() {
    return (tMeterNode *)(tQueue::next());
};

int tMeter::max() {
    tSortNode *temp=sort->max();
    return temp->key;
};

int tMeter::first_value() {
    tMeterNode *temp=first();
    if (temp) return temp->key;
    return 0;
};

int tMeter::last_value() {
    tMeterNode *temp=last();
    if (temp) return temp->key;
    return 0;
};

int tMeter::next_value() {
    tMeterNode *temp=next();
    if (temp)  return temp->key;
    return 0;
};

tMeter::~tMeter() {
    delete(sort);
};
