/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include "sort.h"
#include "stdio.h"

tSortTree::tSortTree() {
    Top=NULL;
};

void tSortTree::init() {
    Top=NULL;
};

void tSortTree::simple_add(tSortNode **where,tSortNode *what) {
    tSortNode **temp=where;
    while (*temp) {
        if ((*temp)->key < what->key)
            temp=&((*temp)->more);
        else
            temp=&((*temp)->less);
    };
    *temp=what;
};

void tSortTree::add(tSortNode *what) {
    simple_add(&Top,what);
    what->less=what->more=NULL;
};

void tSortTree::del(tSortNode *what) {
    tSortNode **temp=&Top;
    while (*temp && *temp!=what) {
        if ((*temp)->key < what->key)
            temp=&((*temp)->more);
        else
            temp=&((*temp)->less);
    };
    *temp=what->less;
    if (what->more) simple_add(temp,what->more);
};

tSortNode *tSortTree::max() {
    tSortNode *temp=Top;
    while (temp->more) {
        temp=temp->more;
    };
    return temp;
};

tSortTree::~tSortTree() {
    //do nothing %))
};
