/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#include <sys/file.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include "main.h"
#include "config.h"
#include "face/list.h"
#include "var.h"
#include "locstr.h"
//-------------------------------------------------
tMain aa;

char *VERSION_NAME="WebDownloader for X 1.0 BETA2";

int main(int argc,char **argv) {
    if (!CFG.GLOBAL_SAVE_PATH)
        CFG.GLOBAL_SAVE_PATH=copy_string(getenv("HOME"));
    char *LOCK_FILE=sum_strings(getenv("HOME"),"/.ntrc/lock");
    read_config();
    LOCK_FILE_D=open(LOCK_FILE,O_TRUNC | O_CREAT |O_RDWR,S_IRUSR | S_IWUSR);
    if (LOCK_FILE<0 || flock(LOCK_FILE_D,LOCK_EX | LOCK_NB)){
    	printf("%s probably is already running\n",VERSION_NAME);
    	return 0;
    };
    delete(LOCK_FILE);
    aa.init();
    init_face(argc,argv);
    aa.init_main_log();
    aa.load_defaults();
    init_timeouts();
    aa.run();
    return 0;
};
