/*	WebDownloader for X-Window
 *	Copyright (C) 1999 Koshelev Maxim
 *	This Program is free but not GPL!!! You can't modify it
 *	without agreement with autor. You can't distribute modified
 *	program but you can distribute unmodified program.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#ifndef MY_SORT_STRINGS_TREE
#define MY_SORT_STRINGS_TREE

#include "liststr.h"
//#include "sort.h"

struct tSortString: public tString{
	tSortString *less,*more;
	int curent,upper,key;
	tSortString();
	tSortString(char *what,int len);
	~tSortString();
};

class tStrSortTree{
	protected:
	tSortString *Top;
	void simple_add(tSortString **where,tSortString *what);
	public:
		tStrSortTree();
		void init();
		void add(tSortString *what);
		void del(tSortString *what);
		void print(tSortString *top);
		tSortString *find(char *what,int key);
		~tStrSortTree();
};


class tHostsLimits:public tStringList{
	protected:
	tStrSortTree *tree;
	public:
		tHostsLimits();
    	virtual void add(char *str,int port,int curent,int upper);
    	void dispose();
		tSortString *find(char *what,int key);
		void del(tSortString *what);
    	tSortString *last();
    	tSortString *first();
    	tSortString *next();
    	tSortString *prev();
		~tHostsLimits();
};
#endif